https://leetcode.com/problems/merge-sorted-array/description/
You are given two integer arrays nums1 and nums2, sorted in non-decreasing order, and two integers m and n, representing the number of elements in nums1 and nums2 respectively.
Merge nums1 and nums2 into a single array sorted in non-decreasing order.
The final sorted array should not be returned by the function, but instead be stored inside the array nums1. To accommodate this, nums1 has a length of m + n, where the first m elements denote the elements that should be merged, and the last n elements are set to 0 and should be ignored. nums2 has a length of n.
Example 1:
Input: nums1 = [1,2,3,0,0,0], m = 3, nums2 = [2,5,6], n = 3
Output: [1,2,2,3,5,6]
Explanation: The arrays we are merging are [1,2,3] and [2,5,6].
The result of the merge is [1,2,2,3,5,6] with the underlined elements coming from nums1.
Example 2:
Input: nums1 = [1], m = 1, nums2 = [], n = 0
Output: [1]
Explanation: The arrays we are merging are [1] and [].
The result of the merge is [1].
Example 3:
Input: nums1 = [0], m = 0, nums2 = [1], n = 1
Output: [1]
Explanation: The arrays we are merging are [] and [1].
The result of the merge is [1].
Note that because m = 0, there are no elements in nums1. The 0 is only there to ensure the merge result can fit in nums1.
Constraints:
- nums1.length == m + n
- nums2.length == n
- 0 <= m, n <= 200
- 1 <= m + n <= 200
- -109 <= nums1[i], nums2[j] <= 109
Follow up: Can you come up with an algorithm that runs in O(m + n) time?
문제부터 넘 길어서 맘에 안 든다.
그래도 Merge Sort부분은 항상 중요한 녀석이라 잘 살펴보아야 하지
1. Python
PASS는 했는데, 누가봐도 꼼수인 답안.. 다시 생각해보자
class Solution:
def merge(self, nums1: List[int], m: int, nums2: List[int], n: int) -> None:
"""
Do not return anything, modify nums1 in-place instead.
"""
for i in range(m,len(nums1)):
nums1[i]=nums2[i-m]
nums1.sort()
이렇게 했는데, nums1 덮어쓰기가 안 된다..
class Solution:
def merge(self, nums1: List[int], m: int, nums2: List[int], n: int) -> None:
"""
Do not return anything, modify nums1 in-place instead.
"""
num = []
n1=0
n2=0
while n1<m and n2<n :
if nums1[n1] < nums2[n2]:
num.append(nums1[n1])
n1+=1
else :
num.append(nums2[n2])
n2+=1
if n1==m:
num += nums2[n2:]
else:
num += nums1[n1:m]
nums1 = num
요런식으로 하면 merge sort가 된다.
class Solution:
def merge(self, nums1: List[int], m: int, nums2: List[int], n: int) -> None:
"""
Do not return anything, modify nums1 in-place instead.
"""
p1 = m-1
p2 = n-1
p = m+n-1
while p1>=0 and p2>=0:
if nums1[p1]<nums2[p2] :
nums1[p] = nums2[p2]
p2+= -1
p+= -1
else:
nums1[p] = nums1[p1]
p1+= -1
p+= -1
if p2<0:
nums1[:p+1]=nums1[:p1+1]
else:
nums1[:p+1]=nums2[:p2+1]
2. C
void merge(int* nums1, int nums1Size, int m, int* nums2, int nums2Size, int n) {
// if(m==0){
// nums1 = nums2;
// return;
// }
int p1 = m-1;
int p2 = n-1;
int p = m+n-1;
while(p1>=0 && p2 >=0){
if(nums1[p1] > nums2[p2]){
nums1[p--] = nums1[p1--];
}else{
nums1[p--] = nums2[p2--];
}
}
if(p2<0){
for(int i=0;i<p+1;i++){
nums1[i] = nums1[i];
}
}
else{
for(int j=0;j<p+1;j++){
nums1[j] = nums2[j];
}
}
}
마지막 if/else 구문이 사실은 m or n 이 0인 case도 다 커버해주고 있었던 것!
3. C++
class Solution {
public:
void merge(vector<int>& nums1, int m, vector<int>& nums2, int n) {
for(int i=m;i<m+n;i++){
nums1[i]=nums2[i-m];
}
sort(nums1.begin(),nums1.end());
}
};
C++은 분노의 sort 사용
rbegin / rend를 쓰면 reverse sort가 가능하다.
'Coding_Practice' 카테고리의 다른 글
C++ Container, Custom Map Practice (0) | 2024.07.29 |
---|---|
Length of Last Word[E,String] (0) | 2024.07.27 |
Search Insert Position[E,Array,Binary Search] (0) | 2024.07.27 |
Convert 1D Array Into 2D Array[E,Array,Matrix,Simulation] (0) | 2024.07.26 |
Adding Spaces to a String[M,ArrayTwo Pointers,String,Simulation] (0) | 2024.07.26 |